Index: sasmodels/core.py
===================================================================
--- sasmodels/core.py	(revision cde11f0f857d1861f37ded681777699e3aa91738)
+++ sasmodels/core.py	(revision d18582e2d66b12afb03e1c3a7c0af6e4449c6bfe)
@@ -2,6 +2,4 @@
 Core model handling routines.
 """
-__all__ = ["list_models", "load_model_definition",  "precompile_dll",
-           "load_model", "make_kernel", "call_kernel", "call_ER", "call_VR" ]
 
 from os.path import basename, dirname, join as joinpath
@@ -22,4 +20,8 @@
     HAVE_OPENCL = False
 
+__all__ = [
+    "list_models", "load_model_definition", "precompile_dll",
+    "load_model", "make_kernel", "call_kernel", "call_ER", "call_VR",
+]
 
 def list_models():
@@ -36,4 +38,7 @@
     """
     Load a model definition given the model name.
+
+    This returns a handle to the module defining the model.  This can be
+    used with functions in generate to build the docs or extract model info.
     """
     __import__('sasmodels.models.'+model_name)
@@ -61,9 +66,12 @@
 
 def isstr(s):
+    """
+    Return True if *s* is a string-like object.
+    """
     try: s + ''
     except: return False
     return True
 
-def load_model(model_definition, dtype="single", platform="ocl"):
+def load_model(model_definition, dtype=None, platform="ocl"):
     """
     Prepare the model for the default execution platform.
@@ -79,5 +87,6 @@
     for the calculation. Any valid numpy single or double precision identifier
     is valid, such as 'single', 'f', 'f32', or np.float32 for single, or
-    'double', 'd', 'f64'  and np.float64 for double.
+    'double', 'd', 'f64'  and np.float64 for double.  If *None*, then use
+    'single' unless the model defines single=False.
 
     *platform* should be "dll" to force the dll to be used for C models,
@@ -86,4 +95,6 @@
     if isstr(model_definition):
         model_definition = load_model_definition(model_definition)
+    if dtype is None:
+        dtype = 'single' if getattr(model_definition, 'single', True) else 'double'
     source, info = generate.make(model_definition)
     if callable(info.get('Iq', None)):
@@ -99,5 +110,5 @@
     # source = open(info['name']+'.cl','r').read()
 
-    if (platform=="dll"
+    if (platform == "dll"
             or not HAVE_OPENCL
             or not kernelcl.environment().has_type(dtype)):
@@ -110,6 +121,5 @@
     Return a computation kernel from the model definition and the q input.
     """
-    model_input = model.make_input(q_vectors)
-    return model(model_input)
+    return model(q_vectors)
 
 def get_weights(info, pars, name):
@@ -128,5 +138,5 @@
     width = pars.get(name+'_pd', 0.0)
     nsigma = pars.get(name+'_pd_nsigma', 3.0)
-    value,weight = weights.get_weights(
+    value, weight = weights.get_weights(
         disperser, npts, width, nsigma, value, limits, relative)
     return value, weight / np.sum(weight)
@@ -195,5 +205,5 @@
                     for name in info['partype']['volume']]
         value, weight = dispersion_mesh(vol_pars)
-        whole,part = VR(*value)
+        whole, part = VR(*value)
         return np.sum(weight*part)/np.sum(weight*whole)
 
Index: sasmodels/data.py
===================================================================
--- sasmodels/data.py	(revision 013adb7ddc1b713ccb5eff4052d37a298cc674e4)
+++ sasmodels/data.py	(revision d18582e2d66b12afb03e1c3a7c0af6e4449c6bfe)
@@ -87,7 +87,42 @@
 
 class Data1D(object):
+    """
+    1D data object.
+
+    Note that this definition matches the attributes from sasview, with
+    some generic 1D data vectors and some SAS specific definitions.  Some
+    refactoring to allow consistent naming conventions between 1D, 2D and
+    SESANS data would be helpful.
+
+    **Attributes**
+
+    *x*, *dx*: $q$ vector and gaussian resolution
+
+    *y*, *dy*: $I(q)$ vector and measurement uncertainty
+
+    *mask*: values to include in plotting/analysis
+
+    *dxl*: slit widths for slit smeared data, with *dx* ignored
+
+    *qmin*, *qmax*: range of $q$ values in *x*
+
+    *filename*: label for the data line
+
+    *_xaxis*, *_xunit*: label and units for the *x* axis
+
+    *_yaxis*, *_yunit*: label and units for the *y* axis
+    """
     def __init__(self, x=None, y=None, dx=None, dy=None):
         self.x, self.y, self.dx, self.dy = x, y, dx, dy
         self.dxl = None
+        self.filename = None
+        self.qmin = x.min() if x is not None else np.NaN
+        self.qmax = x.max() if x is not None else np.NaN
+        # TODO: why is 1D mask False and 2D mask True?
+        self.mask = (np.isnan(y) if y is not None
+                     else np.zeros_like(x, 'b') if x is not None
+                     else None)
+        self._xaxis, self._xunit = "x", ""
+        self._yaxis, self._yunit = "y", ""
 
     def xaxis(self, label, unit):
@@ -108,7 +143,56 @@
 
 class Data2D(object):
-    def __init__(self):
+    """
+    2D data object.
+
+    Note that this definition matches the attributes from sasview. Some
+    refactoring to allow consistent naming conventions between 1D, 2D and
+    SESANS data would be helpful.
+
+    **Attributes**
+
+    *qx_data*, *dqx_data*: $q_x$ matrix and gaussian resolution
+
+    *qy_data*, *dqy_data*: $q_y$ matrix and gaussian resolution
+
+    *data*, *err_data*: $I(q)$ matrix and measurement uncertainty
+
+    *mask*: values to exclude from plotting/analysis
+
+    *qmin*, *qmax*: range of $q$ values in *x*
+
+    *filename*: label for the data line
+
+    *_xaxis*, *_xunit*: label and units for the *x* axis
+
+    *_yaxis*, *_yunit*: label and units for the *y* axis
+
+    *_zaxis*, *_zunit*: label and units for the *y* axis
+
+    *Q_unit*, *I_unit*: units for Q and intensity
+
+    *x_bins*, *y_bins*: grid steps in *x* and *y* directions
+    """
+    def __init__(self, x=None, y=None, z=None, dx=None, dy=None, dz=None):
+        self.qx_data, self.dqx_data = x, dx
+        self.qy_data, self.dqy_data = y, dy
+        self.data, self.err_data = z, dz
+        self.mask = (~np.isnan(z) if z is not None
+                     else np.ones_like(x) if x is not None
+                     else None)
+        self.q_data = np.sqrt(x**2 + y**2)
+        self.qmin = 1e-16
+        self.qmax = np.inf
         self.detector = []
         self.source = Source()
+        self.Q_unit = "1/A"
+        self.I_unit = "1/cm"
+        self.xaxis("Q_x", "1/A")
+        self.yaxis("Q_y", "1/A")
+        self.zaxis("Intensity", "1/cm")
+        self._xaxis, self._xunit = "x", ""
+        self._yaxis, self._yunit = "y", ""
+        self._zaxis, self._zunit = "z", ""
+        self.x_bins, self.y_bins = None, None
 
     def xaxis(self, label, unit):
@@ -135,16 +219,28 @@
 
 class Vector(object):
+    """
+    3-space vector of *x*, *y*, *z*
+    """
     def __init__(self, x=None, y=None, z=None):
         self.x, self.y, self.z = x, y, z
 
 class Detector(object):
+    """
+    Detector attributes.
+    """
+    def __init__(self, pixel_size=(None, None), distance=None):
+        self.pixel_size = Vector(*pixel_size)
+        self.distance = distance
+
+class Source(object):
+    """
+    Beam attributes.
+    """
     def __init__(self):
-        self.pixel_size = Vector()
-
-class Source(object):
-    pass
-
-
-def empty_data1D(q, resolution=0.05):
+        self.wavelength = np.NaN
+        self.wavelength_unit = "A"
+
+
+def empty_data1D(q, resolution=0.0):
     """
     Create empty 1D data using the given *q* as the x value.
@@ -156,12 +252,11 @@
     #dIq = np.sqrt(Iq)
     Iq, dIq = None, None
+    q = np.asarray(q)
     data = Data1D(q, Iq, dx=resolution * q, dy=dIq)
     data.filename = "fake data"
-    data.qmin, data.qmax = q.min(), q.max()
-    data.mask = np.zeros(len(q), dtype='bool')
     return data
 
 
-def empty_data2D(qx, qy=None, resolution=0.05):
+def empty_data2D(qx, qy=None, resolution=0.0):
     """
     Create empty 2D data using the given mesh.
@@ -173,21 +268,10 @@
     if qy is None:
         qy = qx
+    qx, qy = np.asarray(qx), np.asarray(qy)
+    # 5% dQ/Q resolution
     Qx, Qy = np.meshgrid(qx, qy)
     Qx, Qy = Qx.flatten(), Qy.flatten()
     Iq = 100 * np.ones_like(Qx)
     dIq = np.sqrt(Iq)
-    mask = np.ones(len(Iq), dtype='bool')
-
-    data = Data2D()
-    data.filename = "fake data"
-    data.qx_data = Qx
-    data.qy_data = Qy
-    data.data = Iq
-    data.err_data = dIq
-    data.mask = mask
-    data.qmin = 1e-16
-    data.qmax = np.inf
-
-    # 5% dQ/Q resolution
     if resolution != 0:
         # https://www.ncnr.nist.gov/staff/hammouda/distance_learning/chapter_15.pdf
@@ -197,24 +281,19 @@
         # radial (which instead it should be inverse).
         Q = np.sqrt(Qx**2 + Qy**2)
-        data.dqx_data = resolution * Q
-        data.dqy_data = resolution * Q
+        dqx = resolution * Q
+        dqy = resolution * Q
     else:
-        data.dqx_data = data.dqy_data = None
-
-    detector = Detector()
-    detector.pixel_size.x = 5 # mm
-    detector.pixel_size.y = 5 # mm
-    detector.distance = 4 # m
-    data.detector.append(detector)
+        dqx = dqy = None
+
+    data = Data2D(x=Qx, y=Qy, z=Iq, dx=dqx, dy=dqy, dz=dIq)
     data.x_bins = qx
     data.y_bins = qy
+    data.filename = "fake data"
+
+    # pixel_size in mm, distance in m
+    detector = Detector(pixel_size=(5, 5), distance=4)
+    data.detector.append(detector)
     data.source.wavelength = 5 # angstroms
     data.source.wavelength_unit = "A"
-    data.Q_unit = "1/A"
-    data.I_unit = "1/cm"
-    data.q_data = np.sqrt(Qx ** 2 + Qy ** 2)
-    data.xaxis("Q_x", "A^{-1}")
-    data.yaxis("Q_y", "A^{-1}")
-    data.zaxis("Intensity", r"\text{cm}^{-1}")
     return data
 
@@ -223,4 +302,11 @@
     """
     Plot data loaded by the sasview loader.
+
+    *data* is a sasview data object, either 1D, 2D or SESANS.
+
+    *view* is log or linear.
+
+    *limits* sets the intensity limits on the plot; if None then the limits
+    are inferred from the data.
     """
     # Note: kind of weird using the plot result functions to plot just the
@@ -228,28 +314,51 @@
     # do not repeat.
     if hasattr(data, 'lam'):
-        _plot_result_sesans(data, None, None, plot_data=True, limits=limits)
+        _plot_result_sesans(data, None, None, use_data=True, limits=limits)
     elif hasattr(data, 'qx_data'):
-        _plot_result2D(data, None, None, view, plot_data=True, limits=limits)
+        _plot_result2D(data, None, None, view, use_data=True, limits=limits)
     else:
-        _plot_result1D(data, None, None, view, plot_data=True, limits=limits)
+        _plot_result1D(data, None, None, view, use_data=True, limits=limits)
 
 
 def plot_theory(data, theory, resid=None, view='log',
-                plot_data=True, limits=None):
+                use_data=True, limits=None):
+    """
+    Plot theory calculation.
+
+    *data* is needed to define the graph properties such as labels and
+    units, and to define the data mask.
+
+    *theory* is a matrix of the same shape as the data.
+
+    *view* is log or linear
+
+    *use_data* is True if the data should be plotted as well as the theory.
+
+    *limits* sets the intensity limits on the plot; if None then the limits
+    are inferred from the data.
+    """
     if hasattr(data, 'lam'):
-        _plot_result_sesans(data, theory, resid, plot_data=True, limits=limits)
+        _plot_result_sesans(data, theory, resid, use_data=True, limits=limits)
     elif hasattr(data, 'qx_data'):
-        _plot_result2D(data, theory, resid, view, plot_data, limits=limits)
+        _plot_result2D(data, theory, resid, view, use_data, limits=limits)
     else:
-        _plot_result1D(data, theory, resid, view, plot_data, limits=limits)
+        _plot_result1D(data, theory, resid, view, use_data, limits=limits)
 
 
 def protect(fn):
+    """
+    Decorator to wrap calls in an exception trapper which prints the
+    exception and continues.  Keyboard interrupts are ignored.
+    """
     def wrapper(*args, **kw):
+        """
+        Trap and print errors from function.
+        """
         try:
             return fn(*args, **kw)
+        except KeyboardInterrupt:
+            raise
         except:
             traceback.print_exc()
-            pass
 
     return wrapper
@@ -257,5 +366,5 @@
 
 @protect
-def _plot_result1D(data, theory, resid, view, plot_data, limits=None):
+def _plot_result1D(data, theory, resid, view, use_data, limits=None):
     """
     Plot the data and residuals for 1D data.
@@ -264,19 +373,16 @@
     from numpy.ma import masked_array, masked
 
-    plot_theory = theory is not None
-    plot_resid = resid is not None
-
-    if data.y is None:
-        plot_data = False
+    use_data = use_data and data.y is not None
+    use_theory = theory is not None
+    use_resid = resid is not None
+    num_plots = (use_data or use_theory) + use_resid
+
     scale = data.x**4 if view == 'q4' else 1.0
 
-    if plot_data or plot_theory:
-        if plot_resid:
-            plt.subplot(121)
-
+    if use_data or use_theory:
         #print(vmin, vmax)
         all_positive = True
         some_present = False
-        if plot_data:
+        if use_data:
             mdata = masked_array(data.y, data.mask.copy())
             mdata[~np.isfinite(mdata)] = masked
@@ -284,19 +390,22 @@
                 mdata[mdata <= 0] = masked
             plt.errorbar(data.x/10, scale*mdata, yerr=data.dy, fmt='.')
-            all_positive = all_positive and (mdata>0).all()
+            all_positive = all_positive and (mdata > 0).all()
             some_present = some_present or (mdata.count() > 0)
 
 
-        if plot_theory:
+        if use_theory:
             mtheory = masked_array(theory, data.mask.copy())
             mtheory[~np.isfinite(mtheory)] = masked
             if view is 'log':
-                mtheory[mtheory<=0] = masked
+                mtheory[mtheory <= 0] = masked
             plt.plot(data.x/10, scale*mtheory, '-', hold=True)
-            all_positive = all_positive and (mtheory>0).all()
+            all_positive = all_positive and (mtheory > 0).all()
             some_present = some_present or (mtheory.count() > 0)
 
         if limits is not None:
             plt.ylim(*limits)
+
+        if num_plots > 1:
+            plt.subplot(1, num_plots, 1)
         plt.xscale('linear' if not some_present else view)
         plt.yscale('linear'
@@ -306,11 +415,11 @@
         plt.ylabel('$I(q)$')
 
-    if plot_resid:
-        if plot_data or plot_theory:
-            plt.subplot(122)
-
+    if use_resid:
         mresid = masked_array(resid, data.mask.copy())
         mresid[~np.isfinite(mresid)] = masked
         some_present = (mresid.count() > 0)
+
+        if num_plots > 1:
+            plt.subplot(1, num_plots, (use_data or use_theory) + 1)
         plt.plot(data.x/10, mresid, '-')
         plt.xlabel("$q$/nm$^{-1}$")
@@ -320,15 +429,18 @@
 
 @protect
-def _plot_result_sesans(data, theory, resid, plot_data, limits=None):
+def _plot_result_sesans(data, theory, resid, use_data, limits=None):
+    """
+    Plot SESANS results.
+    """
     import matplotlib.pyplot as plt
-    if data.y is None:
-        plot_data = False
-    plot_theory = theory is not None
-    plot_resid = resid is not None
-
-    if plot_data or plot_theory:
-        if plot_resid:
-            plt.subplot(121)
-        if plot_data:
+    use_data = use_data and data.y is not None
+    use_theory = theory is not None
+    use_resid = resid is not None
+    num_plots = (use_data or use_theory) + use_resid
+
+    if use_data or use_theory:
+        if num_plots > 1:
+            plt.subplot(1, num_plots, 1)
+        if use_data:
             plt.errorbar(data.x, data.y, yerr=data.dy)
         if theory is not None:
@@ -340,7 +452,6 @@
 
     if resid is not None:
-        if plot_data or plot_theory:
-            plt.subplot(122)
-
+        if num_plots > 1:
+            plt.subplot(1, num_plots, (use_data or use_theory) + 1)
         plt.plot(data.x, resid, 'x')
         plt.xlabel('spin echo length (nm)')
@@ -349,36 +460,36 @@
 
 @protect
-def _plot_result2D(data, theory, resid, view, plot_data, limits=None):
+def _plot_result2D(data, theory, resid, view, use_data, limits=None):
     """
     Plot the data and residuals for 2D data.
     """
     import matplotlib.pyplot as plt
-    if data.data is None:
-        plot_data = False
-    plot_theory = theory is not None
-    plot_resid = resid is not None
+    use_data = use_data and data.data is not None
+    use_theory = theory is not None
+    use_resid = resid is not None
+    num_plots = use_data + use_theory + use_resid
 
     # Put theory and data on a common colormap scale
-    if limits is None:
-        vmin, vmax = np.inf, -np.inf
-        if plot_data:
-            target = data.data[~data.mask]
-            datamin = target[target>0].min() if view == 'log' else target.min()
-            datamax = target.max()
-            vmin = min(vmin, datamin)
-            vmax = max(vmax, datamax)
-        if plot_theory:
-            theorymin = theory[theory>0].min() if view=='log' else theory.min()
-            theorymax = theory.max()
-            vmin = min(vmin, theorymin)
-            vmax = max(vmax, theorymax)
-    else:
+    vmin, vmax = np.inf, -np.inf
+    if use_data:
+        target = data.data[~data.mask]
+        datamin = target[target > 0].min() if view == 'log' else target.min()
+        datamax = target.max()
+        vmin = min(vmin, datamin)
+        vmax = max(vmax, datamax)
+    if use_theory:
+        theorymin = theory[theory > 0].min() if view == 'log' else theory.min()
+        theorymax = theory.max()
+        vmin = min(vmin, theorymin)
+        vmax = max(vmax, theorymax)
+
+    # Override data limits from the caller
+    if limits is not None:
         vmin, vmax = limits
 
-    if plot_data:
-        if plot_theory and plot_resid:
-            plt.subplot(131)
-        elif plot_theory or plot_resid:
-            plt.subplot(121)
+    # Plot data
+    if use_data:
+        if num_plots > 1:
+            plt.subplot(1, num_plots, 1)
         _plot_2d_signal(data, target, view=view, vmin=vmin, vmax=vmax)
         plt.title('data')
@@ -386,30 +497,23 @@
         h.set_label('$I(q)$')
 
-    if plot_theory:
-        if plot_data and plot_resid:
-            plt.subplot(132)
-        elif plot_data:
-            plt.subplot(122)
-        elif plot_resid:
-            plt.subplot(121)
+    # plot theory
+    if use_theory:
+        if num_plots > 1:
+            plt.subplot(1, num_plots, use_data+1)
         _plot_2d_signal(data, theory, view=view, vmin=vmin, vmax=vmax)
         plt.title('theory')
         h = plt.colorbar()
-        h.set_label(r'$\log_{10}I(q)$' if view=='log'
+        h.set_label(r'$\log_{10}I(q)$' if view == 'log'
                     else r'$q^4 I(q)$' if view == 'q4'
                     else '$I(q)$')
 
-    #if plot_data or plot_theory:
-    #    plt.colorbar()
-
-    if plot_resid:
-        if plot_data and plot_theory:
-            plt.subplot(133)
-        elif plot_data or plot_theory:
-            plt.subplot(122)
+    # plot resid
+    if use_resid:
+        if num_plots > 1:
+            plt.subplot(1, num_plots, use_data+use_theory+1)
         _plot_2d_signal(data, resid, view='linear')
         plt.title('residuals')
         h = plt.colorbar()
-        h.set_label('$\Delta I(q)$')
+        h.set_label(r'$\Delta I(q)$')
 
 
@@ -456,4 +560,7 @@
 
 def demo():
+    """
+    Load and plot a SAS dataset.
+    """
     data = load_data('DEC07086.DAT')
     set_beam_stop(data, 0.004)
Index: sasmodels/direct_model.py
===================================================================
--- sasmodels/direct_model.py	(revision 9404dd3f599fcbe72790aae8a6d176e64f292ea6)
+++ sasmodels/direct_model.py	(revision d18582e2d66b12afb03e1c3a7c0af6e4449c6bfe)
@@ -1,3 +1,25 @@
-import warnings
+"""
+Class interface to the model calculator.
+
+Calling a model is somewhat non-trivial since the functions called depend
+on the data type.  For 1D data the *Iq* kernel needs to be called, for
+2D data the *Iqxy* kernel needs to be called, and for SESANS data the
+*Iq* kernel needs to be called followed by a Hankel transform.  Before
+the kernel is called an appropriate *q* calculation vector needs to be
+constructed.  This is not the simple *q* vector where you have measured
+the data since the resolution calculation will require values beyond the
+range of the measured data.  After the calculation the resolution calculator
+must be called to return the predicted value for each measured data point.
+
+:class:`DirectModel` is a callable object that takes *parameter=value*
+keyword arguments and returns the appropriate theory values for the data.
+
+:class:`DataMixin` does the real work of interpreting the data and calling
+the model calculator.  This is used by :class:`DirectModel`, which uses
+direct parameter values and by :class:`bumps_model.Experiment` which wraps
+the parameter values in boxes so that the user can set fitting ranges, etc.
+on the individual parameters and send the model to the Bumps optimizers.
+"""
+from __future__ import print_function
 
 import numpy as np
@@ -19,6 +41,18 @@
     currently used by :class:`sasview_model.SasviewModel` since this will
     require a number of changes to SasView before we can do it.
+
+    :meth:`_interpret_data` initializes the data structures necessary
+    to manage the calculations.  This sets attributes in the child class
+    such as *data_type* and *resolution*.
+
+    :meth:`_calc_theory` evaluates the model at the given control values.
+
+    :meth:`_set_data` sets the intensity data in the data object,
+    possibly with random noise added.  This is useful for simulating a
+    dataset with the results from :meth:`_calc_theory`.
     """
     def _interpret_data(self, data, model):
+        # pylint: disable=attribute-defined-outside-init
+
         self._data = data
         self._model = model
@@ -36,8 +70,10 @@
         if self.data_type == 'sesans':
             q = sesans.make_q(data.sample.zacceptance, data.Rmax)
-            self.index = slice(None, None)
+            index = slice(None, None)
+            res = None
             if data.y is not None:
-                self.Iq = data.y
-                self.dIq = data.dy
+                Iq, dIq = data.y, data.dy
+            else:
+                Iq, dIq = None, None
             #self._theory = np.zeros_like(q)
             q_vectors = [q]
@@ -49,35 +85,39 @@
             qmax = getattr(data, 'qmax', np.inf)
             accuracy = getattr(data, 'accuracy', 'Low')
-            self.index = ~data.mask & (q >= qmin) & (q <= qmax)
+            index = ~data.mask & (q >= qmin) & (q <= qmax)
             if data.data is not None:
-                self.index &= ~np.isnan(data.data)
-                self.Iq = data.data[self.index]
-                self.dIq = data.err_data[self.index]
-            self.resolution = resolution2d.Pinhole2D(data=data, index=self.index,
-                                                     nsigma=3.0, accuracy=accuracy)
+                index &= ~np.isnan(data.data)
+                Iq = data.data[index]
+                dIq = data.err_data[index]
+            else:
+                Iq, dIq = None, None
+            res = resolution2d.Pinhole2D(data=data, index=index,
+                                         nsigma=3.0, accuracy=accuracy)
             #self._theory = np.zeros_like(self.Iq)
-            q_vectors = self.resolution.q_calc
+            q_vectors = res.q_calc
         elif self.data_type == 'Iq':
-            self.index = (data.x >= data.qmin) & (data.x <= data.qmax)
+            index = (data.x >= data.qmin) & (data.x <= data.qmax)
             if data.y is not None:
-                self.index &= ~np.isnan(data.y)
-                self.Iq = data.y[self.index]
-                self.dIq = data.dy[self.index]
+                index &= ~np.isnan(data.y)
+                Iq = data.y[index]
+                dIq = data.dy[index]
+            else:
+                Iq, dIq = None, None
             if getattr(data, 'dx', None) is not None:
-                q, dq = data.x[self.index], data.dx[self.index]
-                if (dq>0).any():
-                    self.resolution = resolution.Pinhole1D(q, dq)
+                q, dq = data.x[index], data.dx[index]
+                if (dq > 0).any():
+                    res = resolution.Pinhole1D(q, dq)
                 else:
-                    self.resolution = resolution.Perfect1D(q)
-            elif (getattr(data, 'dxl', None) is not None and
-                          getattr(data, 'dxw', None) is not None):
-                self.resolution = resolution.Slit1D(data.x[self.index],
-                                                    width=data.dxh[self.index],
-                                                    height=data.dxw[self.index])
-            else:
-                self.resolution = resolution.Perfect1D(data.x[self.index])
+                    res = resolution.Perfect1D(q)
+            elif (getattr(data, 'dxl', None) is not None
+                  and getattr(data, 'dxw', None) is not None):
+                res = resolution.Slit1D(data.x[index],
+                                        width=data.dxh[index],
+                                        height=data.dxw[index])
+            else:
+                res = resolution.Perfect1D(data.x[index])
 
             #self._theory = np.zeros_like(self.Iq)
-            q_vectors = [self.resolution.q_calc]
+            q_vectors = [res.q_calc]
         else:
             raise ValueError("Unknown data type") # never gets here
@@ -87,6 +127,9 @@
         self._kernel_inputs = [v for v in q_vectors]
         self._kernel = None
+        self.Iq, self.dIq, self.index = Iq, dIq, index
+        self.resolution = res
 
     def _set_data(self, Iq, noise=None):
+        # pylint: disable=attribute-defined-outside-init
         if noise is not None:
             self.dIq = Iq*noise*0.01
@@ -106,6 +149,5 @@
     def _calc_theory(self, pars, cutoff=0.0):
         if self._kernel is None:
-            q_input = self._model.make_input(self._kernel_inputs)
-            self._kernel = self._model(q_input)
+            self._kernel = make_kernel(self._model, self._kernel_inputs)  # pylint: disable=attribute-defined-outside-init
 
         Iq_calc = call_kernel(self._kernel, pars, cutoff=cutoff)
@@ -120,20 +162,50 @@
 
 class DirectModel(DataMixin):
+    """
+    Create a calculator object for a model.
+
+    *data* is 1D SAS, 2D SAS or SESANS data
+
+    *model* is a model calculator return from :func:`generate.load_model`
+
+    *cutoff* is the polydispersity weight cutoff.
+    """
     def __init__(self, data, model, cutoff=1e-5):
         self.model = model
         self.cutoff = cutoff
+        # Note: _interpret_data defines the model attributes
         self._interpret_data(data, model)
-        self.kernel = make_kernel(self.model, self._kernel_inputs)
+
     def __call__(self, **pars):
         return self._calc_theory(pars, cutoff=self.cutoff)
+
     def ER(self, **pars):
+        """
+        Compute the equivalent radius for the model.
+
+        Return 0. if not defined.
+        """
         return call_ER(self.model.info, pars)
+
     def VR(self, **pars):
+        """
+        Compute the equivalent volume for the model, including polydispersity
+        effects.
+
+        Return 1. if not defined.
+        """
         return call_VR(self.model.info, pars)
+
     def simulate_data(self, noise=None, **pars):
+        """
+        Generate simulated data for the model.
+        """
         Iq = self.__call__(**pars)
         self._set_data(Iq, noise=noise)
 
-def demo():
+def main():
+    """
+    Program to evaluate a particular model at a set of q values.
+    """
     import sys
     from .data import empty_data1D, empty_data2D
@@ -144,5 +216,5 @@
     model_name = sys.argv[1]
     call = sys.argv[2].upper()
-    if call not in ("ER","VR"):
+    if call not in ("ER", "VR"):
         try:
             values = [float(v) for v in call.split(',')]
@@ -153,6 +225,6 @@
             data = empty_data1D([q])
         elif len(values) == 2:
-            qx,qy = values
-            data = empty_data2D([qx],[qy])
+            qx, qy = values
+            data = empty_data2D([qx], [qy])
         else:
             print("use q or qx,qy or ER or VR")
@@ -162,9 +234,9 @@
 
     model_definition = load_model_definition(model_name)
-    model = load_model(model_definition, dtype='single')
+    model = load_model(model_definition)
     calculator = DirectModel(data, model)
-    pars = dict((k,float(v))
+    pars = dict((k, float(v))
                 for pair in sys.argv[3:]
-                for k,v in [pair.split('=')])
+                for k, v in [pair.split('=')])
     if call == "ER":
         print(calculator.ER(**pars))
@@ -176,3 +248,3 @@
 
 if __name__ == "__main__":
-    demo()
+    main()
Index: sasmodels/exception.py
===================================================================
--- sasmodels/exception.py	(revision eaca9ebe6d0022b8ac658c30e21ef334fb4f3861)
+++ sasmodels/exception.py	(revision 823e6204f35d6c2bf32f27a3a3c137a369a973cf)
@@ -8,4 +8,7 @@
 except NameError:
     class WindowsError(Exception):
+        """
+        Fake WindowsException when not on Windows.
+        """
         pass
 
@@ -31,5 +34,5 @@
     # TODO: try to incorporate current stack trace in the raised exception
     if isinstance(exc, WindowsError):
-        raise OSError(str(exc)+" "+msg)
+        raise OSError(str(exc) + " " + msg)
 
     args = exc.args
@@ -38,6 +41,6 @@
     else:
         try:
-            arg0 = " ".join((args[0],msg))
+            arg0 = " ".join((args[0], msg))
             exc.args = tuple([arg0] + list(args[1:]))
         except:
-            exc.args = (" ".join((str(exc),msg)),)
+            exc.args = (" ".join((str(exc), msg)),)
